// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::Suggestion;
use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlSuggestionEntry")]
    pub struct SuggestionEntry(Object<ffi::DzlSuggestionEntry, ffi::DzlSuggestionEntryClass>) @extends gtk::Entry, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_suggestion_entry_get_type(),
    }
}

impl SuggestionEntry {
    pub const NONE: Option<&'static SuggestionEntry> = None;

    #[doc(alias = "dzl_suggestion_entry_new")]
    pub fn new() -> SuggestionEntry {
        assert_initialized_main_thread!();
        unsafe { gtk::Widget::from_glib_none(ffi::dzl_suggestion_entry_new()).unsafe_cast() }
    }
}

impl Default for SuggestionEntry {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::SuggestionEntry>> Sealed for T {}
}

pub trait SuggestionEntryExt: IsA<SuggestionEntry> + sealed::Sealed + 'static {
    //#[doc(alias = "dzl_suggestion_entry_default_position_func")]
    //fn default_position_func(&self, area: &mut gdk::Rectangle, is_absolute: bool, user_data: /*Unimplemented*/Option<Basic: Pointer>) {
    //    unsafe { TODO: call ffi:dzl_suggestion_entry_default_position_func() }
    //}

    #[doc(alias = "dzl_suggestion_entry_get_activate_on_single_click")]
    #[doc(alias = "get_activate_on_single_click")]
    fn activates_on_single_click(&self) -> bool {
        unsafe {
            from_glib(ffi::dzl_suggestion_entry_get_activate_on_single_click(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[cfg(feature = "v3_34")]
    #[cfg_attr(docsrs, doc(cfg(feature = "v3_34")))]
    #[doc(alias = "dzl_suggestion_entry_get_compact")]
    #[doc(alias = "get_compact")]
    fn is_compact(&self) -> bool {
        unsafe {
            from_glib(ffi::dzl_suggestion_entry_get_compact(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_suggestion_entry_get_model")]
    #[doc(alias = "get_model")]
    fn model(&self) -> Option<gio::ListModel> {
        unsafe {
            from_glib_none(ffi::dzl_suggestion_entry_get_model(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[cfg(feature = "v3_32")]
    #[cfg_attr(docsrs, doc(cfg(feature = "v3_32")))]
    #[doc(alias = "dzl_suggestion_entry_get_popover")]
    #[doc(alias = "get_popover")]
    fn popover(&self) -> Option<gtk::Widget> {
        unsafe {
            from_glib_none(ffi::dzl_suggestion_entry_get_popover(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_suggestion_entry_get_suggestion")]
    #[doc(alias = "get_suggestion")]
    fn suggestion(&self) -> Option<Suggestion> {
        unsafe {
            from_glib_none(ffi::dzl_suggestion_entry_get_suggestion(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_suggestion_entry_get_typed_text")]
    #[doc(alias = "get_typed_text")]
    fn typed_text(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::dzl_suggestion_entry_get_typed_text(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_suggestion_entry_hide_suggestions")]
    fn hide_suggestions(&self) {
        unsafe {
            ffi::dzl_suggestion_entry_hide_suggestions(self.as_ref().to_glib_none().0);
        }
    }

    #[doc(alias = "dzl_suggestion_entry_set_activate_on_single_click")]
    fn set_activate_on_single_click(&self, activate_on_single_click: bool) {
        unsafe {
            ffi::dzl_suggestion_entry_set_activate_on_single_click(
                self.as_ref().to_glib_none().0,
                activate_on_single_click.into_glib(),
            );
        }
    }

    #[cfg(feature = "v3_34")]
    #[cfg_attr(docsrs, doc(cfg(feature = "v3_34")))]
    #[doc(alias = "dzl_suggestion_entry_set_compact")]
    fn set_compact(&self, compact: bool) {
        unsafe {
            ffi::dzl_suggestion_entry_set_compact(
                self.as_ref().to_glib_none().0,
                compact.into_glib(),
            );
        }
    }

    #[doc(alias = "dzl_suggestion_entry_set_model")]
    fn set_model(&self, model: &impl IsA<gio::ListModel>) {
        unsafe {
            ffi::dzl_suggestion_entry_set_model(
                self.as_ref().to_glib_none().0,
                model.as_ref().to_glib_none().0,
            );
        }
    }

    //#[cfg(feature = "v3_26")]
    //#[cfg_attr(docsrs, doc(cfg(feature = "v3_26")))]
    //#[doc(alias = "dzl_suggestion_entry_set_position_func")]
    //fn set_position_func(&self, func: Option<Box_<dyn Fn(&SuggestionEntry, &gdk::Rectangle, bool) + 'static>>) {
    //    unsafe { TODO: call ffi:dzl_suggestion_entry_set_position_func() }
    //}

    #[doc(alias = "dzl_suggestion_entry_set_suggestion")]
    fn set_suggestion(&self, suggestion: &impl IsA<Suggestion>) {
        unsafe {
            ffi::dzl_suggestion_entry_set_suggestion(
                self.as_ref().to_glib_none().0,
                suggestion.as_ref().to_glib_none().0,
            );
        }
    }

    //#[doc(alias = "dzl_suggestion_entry_window_position_func")]
    //fn window_position_func(&self, area: &mut gdk::Rectangle, is_absolute: bool, user_data: /*Unimplemented*/Option<Basic: Pointer>) {
    //    unsafe { TODO: call ffi:dzl_suggestion_entry_window_position_func() }
    //}

    #[doc(alias = "action")]
    fn connect_action<F: Fn(&Self, &str, &str, &str) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn action_trampoline<
            P: IsA<SuggestionEntry>,
            F: Fn(&P, &str, &str, &str) + 'static,
        >(
            this: *mut ffi::DzlSuggestionEntry,
            object: *mut libc::c_char,
            p0: *mut libc::c_char,
            p1: *mut libc::c_char,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(
                SuggestionEntry::from_glib_borrow(this).unsafe_cast_ref(),
                &glib::GString::from_glib_borrow(object),
                &glib::GString::from_glib_borrow(p0),
                &glib::GString::from_glib_borrow(p1),
            )
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"action\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    action_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    fn emit_action(&self, object: &str, p0: &str, p1: &str) {
        self.emit_by_name::<()>("action", &[&object, &p0, &p1]);
    }

    #[doc(alias = "activate-suggestion")]
    fn connect_activate_suggestion<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn activate_suggestion_trampoline<
            P: IsA<SuggestionEntry>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlSuggestionEntry,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(SuggestionEntry::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"activate-suggestion\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    activate_suggestion_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    fn emit_activate_suggestion(&self) {
        self.emit_by_name::<()>("activate-suggestion", &[]);
    }

    #[doc(alias = "hide-suggestions")]
    fn connect_hide_suggestions<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn hide_suggestions_trampoline<
            P: IsA<SuggestionEntry>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlSuggestionEntry,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(SuggestionEntry::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"hide-suggestions\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    hide_suggestions_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    fn emit_hide_suggestions(&self) {
        self.emit_by_name::<()>("hide-suggestions", &[]);
    }

    #[doc(alias = "move-suggestion")]
    fn connect_move_suggestion<F: Fn(&Self, i32) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn move_suggestion_trampoline<
            P: IsA<SuggestionEntry>,
            F: Fn(&P, i32) + 'static,
        >(
            this: *mut ffi::DzlSuggestionEntry,
            amount: libc::c_int,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(
                SuggestionEntry::from_glib_borrow(this).unsafe_cast_ref(),
                amount,
            )
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"move-suggestion\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    move_suggestion_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    fn emit_move_suggestion(&self, amount: i32) {
        self.emit_by_name::<()>("move-suggestion", &[&amount]);
    }

    #[doc(alias = "show-suggestions")]
    fn connect_show_suggestions<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn show_suggestions_trampoline<
            P: IsA<SuggestionEntry>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlSuggestionEntry,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(SuggestionEntry::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"show-suggestions\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    show_suggestions_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    fn emit_show_suggestions(&self) {
        self.emit_by_name::<()>("show-suggestions", &[]);
    }

    #[doc(alias = "suggestion-activated")]
    fn connect_suggestion_activated<F: Fn(&Self, &Suggestion) + 'static>(
        &self,
        f: F,
    ) -> SignalHandlerId {
        unsafe extern "C" fn suggestion_activated_trampoline<
            P: IsA<SuggestionEntry>,
            F: Fn(&P, &Suggestion) + 'static,
        >(
            this: *mut ffi::DzlSuggestionEntry,
            object: *mut ffi::DzlSuggestion,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(
                SuggestionEntry::from_glib_borrow(this).unsafe_cast_ref(),
                &from_glib_borrow(object),
            )
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"suggestion-activated\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    suggestion_activated_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[cfg(feature = "v3_30")]
    #[cfg_attr(docsrs, doc(cfg(feature = "v3_30")))]
    #[doc(alias = "suggestion-selected")]
    fn connect_suggestion_selected<F: Fn(&Self, &Suggestion) + 'static>(
        &self,
        f: F,
    ) -> SignalHandlerId {
        unsafe extern "C" fn suggestion_selected_trampoline<
            P: IsA<SuggestionEntry>,
            F: Fn(&P, &Suggestion) + 'static,
        >(
            this: *mut ffi::DzlSuggestionEntry,
            suggestion: *mut ffi::DzlSuggestion,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(
                SuggestionEntry::from_glib_borrow(this).unsafe_cast_ref(),
                &from_glib_borrow(suggestion),
            )
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"suggestion-selected\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    suggestion_selected_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[cfg(feature = "v3_30")]
    #[cfg_attr(docsrs, doc(cfg(feature = "v3_30")))]
    #[doc(alias = "activate-on-single-click")]
    fn connect_activate_on_single_click_notify<F: Fn(&Self) + 'static>(
        &self,
        f: F,
    ) -> SignalHandlerId {
        unsafe extern "C" fn notify_activate_on_single_click_trampoline<
            P: IsA<SuggestionEntry>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlSuggestionEntry,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(SuggestionEntry::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::activate-on-single-click\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_activate_on_single_click_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[cfg(feature = "v3_34")]
    #[cfg_attr(docsrs, doc(cfg(feature = "v3_34")))]
    #[doc(alias = "compact")]
    fn connect_compact_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_compact_trampoline<
            P: IsA<SuggestionEntry>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlSuggestionEntry,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(SuggestionEntry::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::compact\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_compact_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "model")]
    fn connect_model_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_model_trampoline<
            P: IsA<SuggestionEntry>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlSuggestionEntry,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(SuggestionEntry::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::model\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_model_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[cfg(feature = "v3_30")]
    #[cfg_attr(docsrs, doc(cfg(feature = "v3_30")))]
    #[doc(alias = "suggestion")]
    fn connect_suggestion_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_suggestion_trampoline<
            P: IsA<SuggestionEntry>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlSuggestionEntry,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(SuggestionEntry::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::suggestion\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_suggestion_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "typed-text")]
    fn connect_typed_text_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_typed_text_trampoline<
            P: IsA<SuggestionEntry>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlSuggestionEntry,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(SuggestionEntry::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::typed-text\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_typed_text_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<SuggestionEntry>> SuggestionEntryExt for O {}

impl fmt::Display for SuggestionEntry {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("SuggestionEntry")
    }
}
